<template>
  <q-dialog
    v-model="showDialog"
    @hide="closeDialog"
    persistent
    v-if="form !== undefined"
  >
    <q-card style="width: 600px; max-width: 80vw">
      <q-bar>
        Editando : {{ form.persona?.apellidoynombre }}
        <q-space />
        <q-btn dense flat icon="close" v-close-popup @click="CancelarDialog">
          <q-tooltip>Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section>
        <div class="row q-col-gutter-xs">
          <div class="col-6">
            <q-input v-model="form.libro" filled dense label="Libro">
              <template v-slot:prepend>
                <q-icon name="auto_stories" />
              </template>
            </q-input>
          </div>
          <div class="col-6">
            <q-input v-model="form.folio" filled dense label="Folio">
              <template v-slot:prepend>
                <q-icon name="library_books" />
              </template>
            </q-input>
          </div>
          <div class="col-12">
            <q-select
              v-model="form.estado_id"
              style="min-width: 150px"
              dense
              filled
              emit-value
              stack-label
              map-options
              :options="[
                { label: 'En Curso', value: 1 },
                { label: 'Acreditado', value: 2 },
                { label: 'No Acredita', value: 5 },
                { label: 'Pendiente Trabajo', value: 3 },
                { label: 'Ausente', value: 6 },
              ]"
              label="Estado: "
            />
          </div>
          <div class="col-12" v-if="form.rama_obligatoria">
            <selectRama v-model="form.rama" :multiple="false" />
          </div>
        </div>
      </q-card-section>
      <q-card-actions align="right">
        <q-btn
          flat
          label="Confirmar Cambios"
          color="primary"
          v-close-popup
          @click="actualizarEstado"
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script lang="ts">
import { PropType, defineComponent, ref, watch } from 'vue';
import { api } from 'src/boot/axios/index';
import { useQuasar } from 'quasar';
import { FormacionParticipantesInterface } from 'src/interfaces/FormacionInterface';
import selectRama from 'src/components/Form/selectRama.vue';

export default defineComponent({
  name: 'DialogEditarCursanteExperiencia',
  props: {
    modelValue: {
      type: Object as PropType<FormacionParticipantesInterface>,
      required: true,
    },
  },
  emits: ['close'],
  components: { selectRama },
  setup(props, { emit }) {
    const $q = useQuasar();
    const showDialog = ref(false);
    const form = ref<FormacionParticipantesInterface>();
    const formOriginal = ref<FormacionParticipantesInterface>();

    watch(
      // LOGICA que abre y cierra el modal detectando si v-model tiene algo.
      () => props.modelValue,
      (newValue) => {
        if (newValue.uuid === undefined) {
          showDialog.value = false;
        } else {
          form.value = props.modelValue;
          formOriginal.value = { ...props.modelValue }; // guado una copia del original para restaural por si se cancela
          showDialog.value = true;
        }
        console.log('Estado modal => ', showDialog.value);
      }
    );

    function actualizarEstado() {
      api
        .put('/api/formacion/participantes', {
          uuid: form.value.uuid,
          libro: form.value.libro,
          folio: form.value.folio,
          rama: form.value.rama,
          estado_id: form.value.estado_id,
        })
        .then(() => {
          closeDialog();
        })
        .catch(() => {
          $q.notify({
            message: 'se genero un error en la edicion',
            color: 'red',
            position: 'top',
          });
          RollBack();
        });
    }

    function RollBack() {
      // si cancelo restauro valores originales !
      form.value.rama = formOriginal.value.rama;
      form.value.libro = formOriginal.value.libro;
      form.value.folio = formOriginal.value.folio;
      form.value.estado_id = formOriginal.value.estado_id;
    }

    function CancelarDialog() {
      RollBack();
      $q.notify({
        message: 'Se cancelo la edicion',
        color: 'red',
        position: 'top',
      });
      closeDialog();
    }

    function closeDialog() {
      showDialog.value = false;
      emit('close');
    }

    return {
      form,
      showDialog,
      closeDialog,
      CancelarDialog,
      actualizarEstado,
    };
  },
});
</script>
